package com.smppw.analysis.domain.dao;

import com.smppw.analysis.domain.dataobject.PrivatelyFundBaseInfoDo;
import com.smppw.analysis.domain.dataobject.PubliclyFundBaseInfoDo;
import com.smppw.analysis.domain.mapper.core.FundInformationMapper;
import org.springframework.stereotype.Component;

@Component
public class FundInformationDao {
//    private final FundFrequencyMapper fundFrequencyMapper;
    private final FundInformationMapper fundInformationMapper;
//    private final MonetaryFundProfitMapper monetaryFundProfitMapper;

    public FundInformationDao(FundInformationMapper fundInformationMapper) {
//        this.fundFrequencyMapper = fundFrequencyMapper;
        this.fundInformationMapper = fundInformationMapper;
//        this.monetaryFundProfitMapper = monetaryFundProfitMapper;
    }

//    /**
//     * 获取多个基金的基本信息
//     *
//     * @param fundIds /
//     * @return /
//     */
//    public List<FundInfoDO> listFundInfo(List<String> fundIds) {
//        return this.fundInformationMapper.queryFundInfoList(fundIds);
//    }
//
//    public FundInfoDO getFundInfoById(String fundId) {
//        List<FundInfoDO> dataList = this.fundInformationMapper.queryFundInfoList(ListUtil.toList(fundId));
//        return dataList.stream().filter(e -> fundId.equals(e.getFundId())).findFirst().orElse(null);
//    }

//    public String getNavFrequencyByFundId(String secId) {
//        return this.fundFrequencyMapper.getNavFrequencyByFundId(secId);
//    }

//    public Map<String, Frequency> getNavFrequency(List<String> secIdList) {
//        Map<String, Frequency> secFrequencyMap = new HashMap<>();
//        List<FundFrequencyDo> fundFrequencyDos = fundFrequencyMapper.getNavFrequencyByFundIdList(secIdList);
//        for (FundFrequencyDo fundFrequencyDo : fundFrequencyDos) {
//            String frequencyStr = fundFrequencyDo.getNavFrequency();
//            Frequency frequency = Frequency.Monthly;
//            if ("天".equals(frequencyStr)) {
//                frequency = Frequency.Daily;
//            } else if ("周".equals(frequencyStr)) {
//                frequency = Frequency.Weekly;
//            }
//            secFrequencyMap.put(fundFrequencyDo.getFundId(), frequency);
//        }
//        return secFrequencyMap;
//    }

//    public Map<String, String> getMarketFundIdNameMap(List<String> fundIdList) {
//        List<FundInformationDo> fundInformationDos = fundInformationMapper.listFundInfo(fundIdList);
//        Map<String, String> fundIdNameMap = new HashMap<>();
//        for (FundInformationDo fundInformationDo : fundInformationDos) {
//            fundIdNameMap.put(fundInformationDo.getFundId(), fundInformationDo.getFundShortName());
//        }
//        return fundIdNameMap;
//    }

//    public List<MonetaryFundProfitDO> queryMonetaryFund(String fundId) {
//        return this.monetaryFundProfitMapper.queryByFundId(fundId);
//    }

    public PrivatelyFundBaseInfoDo listPrivatelyFundInfo(String fundId) {
        return this.fundInformationMapper.listPrivatelyFundInfo(fundId);
    }

    public PubliclyFundBaseInfoDo listPubliclyFundInfo(String fundId) {
        return this.fundInformationMapper.listPublicFundInfo(fundId);
    }
}
