package com.smppw.analysis.domain.dao.info;

import com.smppw.analysis.domain.dataobject.info.PrivateFundInfoDO;
import com.smppw.analysis.domain.mapper.master.CmFundInformationMapper;
import org.springframework.stereotype.Component;

import java.util.List;

@Component(InfoConstants.PRIVATE_FUND_INFO)
public class PrivateFundInfoDao extends AbstractInfoDao<PrivateFundInfoDO> {
    private final CmFundInformationMapper mapper;

    public PrivateFundInfoDao(CmFundInformationMapper mapper) {
        this.mapper = mapper;
    }

    @Override
    protected List<PrivateFundInfoDO> listMultiFundInfo(List<String> subFundIds) {
        return this.mapper.listMultiFundInfo(subFundIds);
    }
}
