package com.smppw.analysis.domain.dao.nav;

import com.smppw.analysis.domain.dataobject.nav.CmNavDo;
import com.smppw.analysis.domain.mapper.master.CmNavMapper;
import com.smppw.common.pojo.enums.Frequency;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

@Component(NavConstants.PRIVATE_FUND_NAV)
public class PrivateFundNavDao extends AbstractNavDao<CmNavDo> {
    private final CmNavMapper cmNavMapper;

    public PrivateFundNavDao(CmNavMapper cmNavMapper) {
        this.cmNavMapper = cmNavMapper;
    }

    @Override
    protected List<CmNavDo> listSecNav(List<String> secIds, String startDate, String endDate, Integer curveTypeId, Integer strategyId, Map<String, Frequency> secFrequencyMap) {
        return this.cmNavMapper.listNav(secIds, startDate, endDate);
    }
}
